<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AllocUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/eclipse/papyrus/designer/deployment/tools/AllocUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.deployment.tools;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Collection;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.UniqueEList;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.MARTE.MARTE_DesignModel.SRM.SW_Concurrency.SwSchedulableResource;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.MARTE.MARTE_Foundations.Alloc.Allocate;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.ElementUtils;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.ConnectorUtil;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Abstraction;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Connector;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ConnectorEnd;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.DirectedRelationship;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Node;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Slot;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/designer/deployment/tools/AllocUtils.html">AllocUtils</a> {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String startPortName = <span class="jxr_string">"start"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String startPortType = <span class="jxr_string">"IStart"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 * Retrieve a list of nodes to which the instance is allocated to *or*</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * to which one of the contained instances is allocated to (recursively)</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 * @return a list of nodes</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;InstanceSpecification&gt; getAllNodes(InstanceSpecification instance) {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  		EList&lt;InstanceSpecification&gt; nodeList = getNodes(instance);
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		<strong class="jxr_keyword">for</strong> (Slot slot : instance.getSlots()) {
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  			<strong class="jxr_keyword">if</strong> (!DepUtils.isShared(slot)) {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  				InstanceSpecification containedInstance = DepUtils.getInstance(slot);
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  				<strong class="jxr_keyword">if</strong> (containedInstance != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  					nodeList.addAll(getAllNodes(containedInstance));
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  				}
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			}
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		}
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		<strong class="jxr_keyword">return</strong> nodeList;
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	}
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment">	 * Retrieve a list of nodes to which the set of passed instance is allocated to *or*</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment">	 * to which one of the contained instances is allocated to (recursively)</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment">	 * @param instanceList a list of instances</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment">	 * @return a list of nodes</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;InstanceSpecification&gt; getAllNodes(Collection&lt;InstanceSpecification&gt; instances) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		EList&lt;InstanceSpecification&gt; nodeList = <strong class="jxr_keyword">new</strong> UniqueEList&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">for</strong> (InstanceSpecification instance : instances) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  			nodeList.addAll(getAllNodes(instance));
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		<strong class="jxr_keyword">return</strong> nodeList;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  	}
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 * Retrieve a list of nodes to which the instance is allocated to *or*</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 * to which one of the contained instances is allocated to (recursively)</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 * @param instanceAttribute</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 *            an attribute within a composite that represents a component instance</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 *            or a set thereof, if the composite itself is instantiated multiple times)</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 * @return a list of nodes</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Property getThreadAlloc(Property instanceAttribute) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  		<strong class="jxr_keyword">for</strong> (DirectedRelationship relation : instanceAttribute.getSourceDirectedRelationships()) {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  			<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(relation, Allocate.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  				<strong class="jxr_keyword">if</strong> (relation.getTargets().size() != 1) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  					<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  				}
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  				Element targetElem = relation.getTargets().get(0);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  				<strong class="jxr_keyword">if</strong> (!(targetElem instanceof Property)) {
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 					<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 				}
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 				Property target = (Property) targetElem;
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 				<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(target.getType(), SwSchedulableResource.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 					<strong class="jxr_keyword">return</strong> target;
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 				}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			}
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		}
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 	}
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> <em class="jxr_javadoccomment">	 * Retrieve a list of nodes to which the instance is allocated to *or*</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> <em class="jxr_javadoccomment">	 * to which one of the containing instances is explicitly allocated</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_javadoccomment">	 * @return a list of nodes</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;InstanceSpecification&gt; getAllNodesOrThreadsParent(InstanceSpecification instance) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		EList&lt;InstanceSpecification&gt; nodeList = getNodesOrThreads(instance);
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		Package cdp = instance.getNearestPackage();
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		<em class="jxr_comment">// TODO: not very efficient: loop each time over all instance specifications</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		<strong class="jxr_keyword">for</strong> (NamedElement parentNE : cdp.getMembers()) {
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			<strong class="jxr_keyword">if</strong> (parentNE instanceof InstanceSpecification) {
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 				<em class="jxr_comment">// possible parent instance specification</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 				InstanceSpecification parentIS = (InstanceSpecification) parentNE;
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 				<strong class="jxr_keyword">if</strong> (DepUtils.getContainedInstances(parentIS).contains(instance)) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 					nodeList.addAll(getAllNodesOrThreadsParent(parentIS));
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 				}
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 			}
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		<strong class="jxr_keyword">return</strong> nodeList;
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	}
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> InstanceSpecification getNode(InstanceSpecification instance) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		EList&lt;InstanceSpecification&gt; nodeList = getNodes(instance);
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		<strong class="jxr_keyword">if</strong> (nodeList.size() != 0) {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			<strong class="jxr_keyword">return</strong> nodeList.get(0);
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 	}
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> InstanceSpecification getNodeOrThread(InstanceSpecification instanceOrThread) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		EList&lt;InstanceSpecification&gt; nodeList = getNodesOrThreads(instanceOrThread);
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		<strong class="jxr_keyword">if</strong> (nodeList.size() != 0) {
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			<strong class="jxr_keyword">return</strong> nodeList.get(0);
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		}
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 	}
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> <em class="jxr_javadoccomment">	 * This method returns a list of nodes (or threads) to which the passed instance is allocated.</em>
<a class="jxr_linenumber" name="L153" href="#L153">153</a> <em class="jxr_javadoccomment">	 * It is based on MARTE Allocation (a stereotyped abstraction) which is a generic</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> <em class="jxr_javadoccomment">	 * mechanism to deploy UML elements to nodes.</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> <em class="jxr_javadoccomment">	 * @param instanceOrThread</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> <em class="jxr_javadoccomment">	 *            The instance for which we like to know the allocation information</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;InstanceSpecification&gt; getNodesOrThreads(InstanceSpecification instanceOrThread) {
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		EList&lt;InstanceSpecification&gt; nodeList = <strong class="jxr_keyword">new</strong> UniqueEList&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		<strong class="jxr_keyword">for</strong> (DirectedRelationship relationship : instanceOrThread.getSourceDirectedRelationships(UMLPackage.eINSTANCE.getAbstraction())) {
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 			Abstraction abstraction = (Abstraction) relationship;
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 			<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(abstraction, Allocate.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 				<strong class="jxr_keyword">for</strong> (Element target : abstraction.getTargets()) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 					<strong class="jxr_keyword">if</strong> (target instanceof InstanceSpecification) {
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 						nodeList.add((InstanceSpecification) target);
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 					}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 				}
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 			}
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		}
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 		<strong class="jxr_keyword">return</strong> nodeList;
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 	}
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> <em class="jxr_javadoccomment">	 * This method returns a list of nodes to which the passed instance is allocated. If</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> <em class="jxr_javadoccomment">	 * the instance is allocated directly to a node, this node is returned. If the instance</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> <em class="jxr_javadoccomment">	 * is allocated to a thread, the allocation of the thread to a node is returned.</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> <em class="jxr_javadoccomment">	 * @param instanceOrThread</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> <em class="jxr_javadoccomment">	 *            The instance that should be deployed</em>
<a class="jxr_linenumber" name="L183" href="#L183">183</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;InstanceSpecification&gt; getNodes(InstanceSpecification instanceOrThread) {
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		EList&lt;InstanceSpecification&gt; nodeList = <strong class="jxr_keyword">new</strong> UniqueEList&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 		EList&lt;InstanceSpecification&gt; nodeOrThreads = getNodesOrThreads(instanceOrThread);
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification nodeOrThread : nodeOrThreads)
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 		{
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 			Classifier nodeOrThreadC = DepUtils.getClassifier(nodeOrThread);
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(nodeOrThreadC, SwSchedulableResource.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 				<em class="jxr_comment">// treat case that instance is allocated to a thread</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 				<em class="jxr_comment">// follow allocation of Thread</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 				nodeList.add(getNode(nodeOrThread));
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 				nodeList.add(nodeOrThread);
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 			}
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		}
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 		<strong class="jxr_keyword">return</strong> nodeList;
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 	}
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 * This method updates (and optionally removes) the allocations of an instance</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> <em class="jxr_javadoccomment">	 *            The instance that should be deployed</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> <em class="jxr_javadoccomment">	 * @param oldNode</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> <em class="jxr_javadoccomment">	 *            the old node allocation</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> <em class="jxr_javadoccomment">	 * @param newNode</em>
<a class="jxr_linenumber" name="L211" href="#L211">211</a> <em class="jxr_javadoccomment">	 *            the new node allocation, may be null to indicate removal</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Node&gt; updateAllocation(InstanceSpecification instance, InstanceSpecification oldNode, InstanceSpecification newNode) {
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 		EList&lt;Node&gt; nodeList = <strong class="jxr_keyword">new</strong> UniqueEList&lt;Node&gt;();
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		Iterator&lt;DirectedRelationship&gt; relShipIt =
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 				instance.getSourceDirectedRelationships(UMLPackage.eINSTANCE.getAbstraction()).iterator();
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 		<strong class="jxr_keyword">while</strong> (relShipIt.hasNext()) {
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 			Abstraction abstraction = (Abstraction) relShipIt.next();
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 			<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(abstraction, Allocate.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 				EList&lt;NamedElement&gt; suppliers = abstraction.getSuppliers(); <em class="jxr_comment">// use suppliers instead of targets (derived)</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 				<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> index = 0; index &lt; suppliers.size(); index++) {
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 					<strong class="jxr_keyword">if</strong> (suppliers.get(index) == oldNode) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 						<strong class="jxr_keyword">if</strong> (newNode == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 							<em class="jxr_comment">// remove relationship completely, since we assume a single target</em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 							<em class="jxr_comment">// (cannot call remove on relShipIt, since list is derived)</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 							abstraction.destroy();
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 						} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 							suppliers.set(index, newNode);
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 						}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 						<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 					}
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 				}
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			}
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 		}
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		<strong class="jxr_keyword">return</strong> nodeList;
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 	}
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> <em class="jxr_javadoccomment">	 * Retrieve a list of nodes to which the instance is allocated to *or*</em>
<a class="jxr_linenumber" name="L243" href="#L243">243</a> <em class="jxr_javadoccomment">	 * to which one of the contained instances is allocated to (recursively)</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_javadoccomment">	 * @param A</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_javadoccomment">	 *            port of the composite. Contained instances are examined only if</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> <em class="jxr_javadoccomment">	 *            they have a connection with this port.</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> <em class="jxr_javadoccomment">	 * @return a list of nodes</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;InstanceSpecification&gt; getAllNodesForPort(InstanceSpecification instance, Port port) {
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 		EList&lt;InstanceSpecification&gt; nodeList = getNodes(instance);
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 		Classifier composite = DepUtils.getClassifier(instance);
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 		<strong class="jxr_keyword">if</strong> (composite instanceof Class) {
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 			Class compositeCL = (Class) composite;
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 			<strong class="jxr_keyword">for</strong> (Slot slot : instance.getSlots()) {
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 				Property containedProperty = (Property) slot.getDefiningFeature();
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 				<strong class="jxr_keyword">for</strong> (Connector connection : compositeCL.getOwnedConnectors()) {
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 					<em class="jxr_comment">// is one connector end targeted at the containedProperty ?</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 					ConnectorEnd end = ConnectorUtil.connEndForPart(connection, containedProperty);
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 					<strong class="jxr_keyword">if</strong> (end == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 						<strong class="jxr_keyword">continue</strong>;
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 					}
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 					<em class="jxr_comment">// does the connector at the same connect the composite's port?</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 					<strong class="jxr_keyword">if</strong> (ConnectorUtil.connectsPort(connection, port)) {
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 						Port containedPort = (Port) end.getRole();
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 						nodeList.addAll(getAllNodesForPort(DepUtils.getInstance(slot), containedPort));
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 					}
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 				}
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 			}
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 		}
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 		<strong class="jxr_keyword">return</strong> nodeList;
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 	}
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> allocate(InstanceSpecification instance, InstanceSpecification node) {
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 		Package cdp = (Package) instance.getOwner();
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 		Abstraction allocation = (Abstraction)
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 				cdp.createPackagedElement(<span class="jxr_string">"allocate "</span> + instance.getName() + <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 						<span class="jxr_string">" to "</span> + node.getName(), UMLPackage.eINSTANCE.getAbstraction()); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 		<strong class="jxr_keyword">if</strong> (StereotypeUtil.apply(allocation, Allocate.<strong class="jxr_keyword">class</strong>) == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 			<em class="jxr_comment">// stereotype application failed</em>
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			allocation.destroy();
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 			<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 		}
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		allocation.getClients().add(instance);
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 		allocation.getSuppliers().add(node);
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 	}
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L293" href="#L293">293</a> <em class="jxr_javadoccomment">	 * Assign node name to leafs</em>
<a class="jxr_linenumber" name="L294" href="#L294">294</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L295" href="#L295">295</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L296" href="#L296">296</a> <em class="jxr_javadoccomment">	 * @param A</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> <em class="jxr_javadoccomment">	 *            port of the composite. Contained instances are examined only if the</em>
<a class="jxr_linenumber" name="L298" href="#L298">298</a> <em class="jxr_javadoccomment">	 *            have a connection with this port. If null, no sub-instances are examined</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> <em class="jxr_javadoccomment">	 * @param nodes</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> <em class="jxr_javadoccomment">	 *            A list of nodes to which leafs are allocated</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> propagateNodesViaPort(InstanceSpecification instance, Port port, EList&lt;InstanceSpecification&gt; nodes) {
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 		<strong class="jxr_keyword">if</strong> (instance == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 		}
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 		EList&lt;Slot&gt; slots = instance.getSlots();
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 		Class composite = DepUtils.getImplementation(instance);
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 		<em class="jxr_comment">// Only set allocation on leafs (TODO: assure that components with configuration attributes are not considered as leafs)</em>
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 		<em class="jxr_comment">// if(composite.getParts().size() == 0) {</em>
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification node : nodes) {
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 			AllocUtils.allocate(instance, node);
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 		}
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 		<strong class="jxr_keyword">if</strong> ((composite != <strong class="jxr_keyword">null</strong>) &amp;&amp; (port != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 			Class compositeCL = composite;
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 			<strong class="jxr_keyword">for</strong> (Slot slot : slots) {
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 				Property containedProperty = (Property) slot.getDefiningFeature();
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 				<strong class="jxr_keyword">for</strong> (Connector connection : compositeCL.getOwnedConnectors()) {
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 					<strong class="jxr_keyword">if</strong> (ConnectorUtil.connectsPort(connection, port)) {
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 						ConnectorEnd end = ConnectorUtil.connEndForPart(connection, containedProperty);
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 						<em class="jxr_comment">// other connector end targeted at containedProperty?</em>
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 						<strong class="jxr_keyword">if</strong> (end != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 							Port containedPort = (Port) end.getRole();
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 							propagateNodesViaPort(DepUtils.getInstance(slot), containedPort, nodes);
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 						}
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 					}
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 				}
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 			}
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 		}
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 	}
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L335" href="#L335">335</a> <em class="jxr_javadoccomment">	 * Return the start Port of a component, i.e. a port that corresponds to the "magic" port name</em>
<a class="jxr_linenumber" name="L336" href="#L336">336</a> <em class="jxr_javadoccomment">	 * start and is typed with the interface IStart</em>
<a class="jxr_linenumber" name="L337" href="#L337">337</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L338" href="#L338">338</a> <em class="jxr_javadoccomment">	 * @param component</em>
<a class="jxr_linenumber" name="L339" href="#L339">339</a> <em class="jxr_javadoccomment">	 *            a component implementation</em>
<a class="jxr_linenumber" name="L340" href="#L340">340</a> <em class="jxr_javadoccomment">	 * @return The start port or null</em>
<a class="jxr_linenumber" name="L341" href="#L341">341</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Port getStartPort(Class component) {
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 		Element startPortElem = ElementUtils.getNamedElementFromList(component.getAllAttributes(), startPortName);
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 		<strong class="jxr_keyword">if</strong> (startPortElem instanceof Port) {
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 			Port startPort = (Port) startPortElem;
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 			<strong class="jxr_keyword">if</strong> (startPort.getType().getName().equals(startPortType)) {
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 				<strong class="jxr_keyword">return</strong> startPort;
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 			}
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 		}
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 	}
<a class="jxr_linenumber" name="L352" href="#L352">352</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
